// Copyright (c) 2005-2014 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/pre.hxx>

#include "XAdESv141.hxx"

namespace digidoc
{
  namespace xadesv141
  {
    // ValidationDataType
    // 

    const ValidationDataType::CertificateValuesOptional& ValidationDataType::
    certificateValues () const
    {
      return this->CertificateValues_;
    }

    ValidationDataType::CertificateValuesOptional& ValidationDataType::
    certificateValues ()
    {
      return this->CertificateValues_;
    }

    void ValidationDataType::
    certificateValues (const CertificateValuesType& x)
    {
      this->CertificateValues_.set (x);
    }

    void ValidationDataType::
    certificateValues (const CertificateValuesOptional& x)
    {
      this->CertificateValues_ = x;
    }

    void ValidationDataType::
    certificateValues (::std::unique_ptr< CertificateValuesType > x)
    {
      this->CertificateValues_.set (std::move (x));
    }

    const ValidationDataType::RevocationValuesOptional& ValidationDataType::
    revocationValues () const
    {
      return this->RevocationValues_;
    }

    ValidationDataType::RevocationValuesOptional& ValidationDataType::
    revocationValues ()
    {
      return this->RevocationValues_;
    }

    void ValidationDataType::
    revocationValues (const RevocationValuesType& x)
    {
      this->RevocationValues_.set (x);
    }

    void ValidationDataType::
    revocationValues (const RevocationValuesOptional& x)
    {
      this->RevocationValues_ = x;
    }

    void ValidationDataType::
    revocationValues (::std::unique_ptr< RevocationValuesType > x)
    {
      this->RevocationValues_.set (std::move (x));
    }

    const ValidationDataType::IdOptional& ValidationDataType::
    id () const
    {
      return this->Id_;
    }

    ValidationDataType::IdOptional& ValidationDataType::
    id ()
    {
      return this->Id_;
    }

    void ValidationDataType::
    id (const IdType& x)
    {
      this->Id_.set (x);
    }

    void ValidationDataType::
    id (const IdOptional& x)
    {
      this->Id_ = x;
    }

    void ValidationDataType::
    id (::std::unique_ptr< IdType > x)
    {
      this->Id_.set (std::move (x));
    }

    const ValidationDataType::URIOptional& ValidationDataType::
    uRI () const
    {
      return this->URI_;
    }

    ValidationDataType::URIOptional& ValidationDataType::
    uRI ()
    {
      return this->URI_;
    }

    void ValidationDataType::
    uRI (const URIType& x)
    {
      this->URI_.set (x);
    }

    void ValidationDataType::
    uRI (const URIOptional& x)
    {
      this->URI_ = x;
    }

    void ValidationDataType::
    uRI (::std::unique_ptr< URIType > x)
    {
      this->URI_.set (std::move (x));
    }
  }
}

#include <xsd/cxx/xml/dom/parsing-source.hxx>

namespace digidoc
{
  namespace xadesv141
  {
    // ValidationDataType
    //

    ValidationDataType::
    ValidationDataType ()
    : ::xml_schema::Type (),
      CertificateValues_ (this),
      RevocationValues_ (this),
      Id_ (this),
      URI_ (this)
    {
    }

    ValidationDataType::
    ValidationDataType (const ValidationDataType& x,
                        ::xml_schema::Flags f,
                        ::xml_schema::Container* c)
    : ::xml_schema::Type (x, f, c),
      CertificateValues_ (x.CertificateValues_, f, this),
      RevocationValues_ (x.RevocationValues_, f, this),
      Id_ (x.Id_, f, this),
      URI_ (x.URI_, f, this)
    {
    }

    ValidationDataType::
    ValidationDataType (const ::xercesc::DOMElement& e,
                        ::xml_schema::Flags f,
                        ::xml_schema::Container* c)
    : ::xml_schema::Type (e, f | ::xml_schema::Flags::base, c),
      CertificateValues_ (this),
      RevocationValues_ (this),
      Id_ (this),
      URI_ (this)
    {
      if ((f & ::xml_schema::Flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, true, false, true);
        this->parse (p, f);
      }
    }

    void ValidationDataType::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::Flags f)
    {
      for (; p.more_content (); p.next_content (false))
      {
        const ::xercesc::DOMElement& i (p.cur_element ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        // CertificateValues
        //
        if (n.name () == "CertificateValues" && n.namespace_ () == "http://uri.etsi.org/01903/v1.3.2#")
        {
          ::std::unique_ptr< CertificateValuesType > r (
            CertificateValuesTraits::create (i, f, this));

          if (!this->CertificateValues_)
          {
            this->CertificateValues_.set (::std::move (r));
            continue;
          }
        }

        // RevocationValues
        //
        if (n.name () == "RevocationValues" && n.namespace_ () == "http://uri.etsi.org/01903/v1.3.2#")
        {
          ::std::unique_ptr< RevocationValuesType > r (
            RevocationValuesTraits::create (i, f, this));

          if (!this->RevocationValues_)
          {
            this->RevocationValues_.set (::std::move (r));
            continue;
          }
        }

        break;
      }

      while (p.more_attributes ())
      {
        const ::xercesc::DOMAttr& i (p.next_attribute ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        if (n.name () == "Id" && n.namespace_ ().empty ())
        {
          this->Id_.set (IdTraits::create (i, f, this));
          continue;
        }

        if (n.name () == "URI" && n.namespace_ ().empty ())
        {
          this->URI_.set (URITraits::create (i, f, this));
          continue;
        }
      }
    }

    ValidationDataType* ValidationDataType::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class ValidationDataType (*this, f, c);
    }

    ValidationDataType& ValidationDataType::
    operator= (const ValidationDataType& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::Type& > (*this) = x;
        this->CertificateValues_ = x.CertificateValues_;
        this->RevocationValues_ = x.RevocationValues_;
        this->Id_ = x.Id_;
        this->URI_ = x.URI_;
      }

      return *this;
    }

    ValidationDataType::
    ~ValidationDataType ()
    {
    }
  }
}

#include <istream>
#include <xsd/cxx/xml/sax/std-input-source.hxx>
#include <xsd/cxx/tree/error-handler.hxx>

namespace digidoc
{
  namespace xadesv141
  {
  }
}

#include <ostream>
#include <xsd/cxx/tree/error-handler.hxx>
#include <xsd/cxx/xml/dom/serialization-source.hxx>

namespace digidoc
{
  namespace xadesv141
  {
    void
    operator<< (::xercesc::DOMElement& e, const ValidationDataType& i)
    {
      e << static_cast< const ::xml_schema::Type& > (i);

      // CertificateValues
      //
      if (i.certificateValues ())
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "CertificateValues",
            "http://uri.etsi.org/01903/v1.3.2#",
            e));

        s << *i.certificateValues ();
      }

      // RevocationValues
      //
      if (i.revocationValues ())
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "RevocationValues",
            "http://uri.etsi.org/01903/v1.3.2#",
            e));

        s << *i.revocationValues ();
      }

      // Id
      //
      if (i.id ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "Id",
            e));

        a << *i.id ();
      }

      // URI
      //
      if (i.uRI ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "URI",
            e));

        a << *i.uRI ();
      }
    }
  }
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

